module Transmission
  class BaseMethod
    def initialize( client )
      @client = client
    end

    def request
      request = {
          method: @method,
          arguments: @arguments
      }
      response = @client.class.post(@client.base_uri, basic_auth: @client.auth, headers: @client.headers, body: request.to_json )
      if response.code == 409
        @client.headers["x-transmission-session-id"] = response.headers["x-transmission-session-id"]
        response = @client.class.post(@client.base_uri, basic_auth: @client.auth, headers: @client.headers, body: request.to_json )
      end
      raise ResponseError.new(response) if response.code != 200
      Mash.new(response)
    end
  end
end